// B O T O

require('dotenv').config();
const tmi = require('tmi.js');

console.log(process.env.API_HOST);

const client = new tmi.Client({
  options: { debug: true },
  connection: {
    secure: true,
    reconnect: true
  },
  identity: {
    username: process.env.TTV_BOT_USERNAME,
    password: process.env.TTV_BOT_OAUTH
  },
  channels: [ process.env.TTV_CHANNELS ]
});

client.connect();

// SCAN MSG | START
client.on('message', (channel, tags, message, self) => {
    if(self) return;
    const badges = tags.badges || {}; // Scan Badges
    const isBroadcaster = badges.broadcaster; // Define Streamer
    const isMod = badges.moderator; // Define Mod
    const isModUp = isBroadcaster || isMod; // Permission Merge = Mod+Streamer
    const isSub = badges.subscriber || badges.founder; // Define Subs
    const botUserState = client.userstate[channel]; // MOD Status Check
    const amMod = botUserState !== undefined && botUserState.mod === true; // Define Mod Status

    if(self || !message.startsWith('!')) return; // Command Parser
    const args = message.slice(1).split(' ');
    const command = args.shift().toLowerCase(); // !COMMAND => command

    // CHAT COMMANDS | Start

    // The Color
    if(command === 'color') {
      // Change your username color. Color must be in hex (#000000) or one of the following: Blue, BlueViolet, CadetBlue, Chocolate, Coral, DodgerBlue, Firebrick, GoldenRod, Green, HotPink, OrangeRed, Red, SeaGreen, SpringGreen, YellowGreen.
      client.say(channel, `/color ${args.join(' ')}`);
      client.say(channel, `/me Bleep! Bloop! @${tags.username} has changed my color to ${args.join(' ')}`);
      client.say(channel, `/me Out of the entire hex (#000000) spectrum or the preset color names: Blue, BlueViolet, CadetBlue, Chocolate, Coral, DodgerBlue, Firebrick, GoldenRod, Green, HotPink, OrangeRed, Red, SeaGreen, SpringGreen, YellowGreen you choose ${args.join(' ')}... Welp, alright!`);
    }
    // CORD
    if(command === 'cord' ||
    command === 'discord') {
      client.say(channel, `/me The Cord by Sarimoko is joinable & sharable at: https://cord.sarimoko.com/`);
    }
    // CREW
    if(command === 'crew' ||
    command === 'mod' ||
    command === 'mods' ||
    command === 'vip' ||
    command === 'vips') {
      client.say(channel, `!kappagen sarimoLURKbrb sarimoBANG sarimoHYPE `);
      client.say(channel, `/me Bleep-Bloop! Mods Squad:`);
      client.say(channel, `/mods`);
      client.say(channel, `/me Bleep-Bloop! Honored VIPs:`);
      client.say(channel, `/vips`);
    }
    // Dice Roll
    if(command === 'dice' ||
    command === 'roll') {
    const result = Math.floor(Math.random() * 6) + 1;
    client.say(channel, `@${tags.username} has rolled a ${result}! Praise RNGesus!`);
    }
    // DOJO
    if(command === 'dojo' ||
    command === 'lessons') {
      client.say(channel, `/me The Dojo | Get 1on1 training from Sarimoko or browse his collection of DIY coarses, guides, lessons, & tutorials available at: https://dojo.sarimoko.com/`);
    }
    // RULE
    if(command === 'rule' ||
    command === 'rules') {
      client.say(channel, `Chat Rule Reminder`);
      client.say(channel, `/me 1. Do NOT feed the Trolls!`);
      client.say(channel, `/me 2. Do NOT be a Troll!`);
      client.say(channel, `/me 3. Do NOT be another brick in the wall!`);
    }
    // TUNE
    if(command === 'tune' ||
    command === 'lyrics' ||
    command === 'midi' ||
    command === 'tabs') {
      client.say(channel, `/me The Tune | Lyrics, MIDI, Tabs, & more hosted on Git written in Markdown available at: https://dojo.sarimoko.com/`);
    }

    // CHAT COMMANDS | End

    if(isSub) { // SUB | Start

      // HYPE
      if(command === 'hype' ||
      command === 'train' ||
      command === 'hypetrain') {
        client.say(channel, `!kappagen sarimoHYPE sarimoBITS sarimoHYPE sarimoBITS`);
      }

    } // SUB | END

    if(isModUp) { // MOD Start

      // Shoutout
      if(command === 'so' ||
      command === 'shoutout') {
        client.say(channel, `/me Bleep! Bloop! Roll the clip! Smash @${args.join(' ')}'s follow button at: https://twitch.tv/${args.join(' ')}`);
      }

      // MOD TOOLS

      // CHAT MODES
      // Emotes
      if(command === 'emoteonly') {
        client.say(channel, `/me Bleep! Bloop! ${tags.username} just activated EMOTE ONLY chat! Show Sir SPAM'a'LOT who's boss!`);
        client.say(channel, `/emoteonly `);
      }
      if(command === 'emoteoff' ||
      command === 'emoteonlyoff') {
        client.say(channel, `/me Bleep! Bloop! ${tags.username} turned off EMOTE ONLY chat! Chatter freely!`);
        client.say(channel, `/emoteonlyoff `);
      }
      // Slow
      if(command === 'slow' ||
      command === 'slowchat') {
        client.say(channel, `/me Bleep! Bloop! ${tags.username} just activated SLOW MODE chat! Send a message every ${args.join(' ')} seconds, that give @Sarimoko time to ketchup!`);
        client.say(channel, `/slow ${args.join(' ')}`);
      }
      if(command === 'slowoff' ||
      command === 'slowchatoff') {
        client.say(channel, `/me Bleep! Bloop! ${tags.username} turned off SLOW MODE chat! Chatter freely!`);
        client.say(channel, `/slowoff `);
      }
      // Subs
      if(command === 'subsonly') {
        client.say(channel, `/me Bleep! Bloop! ${tags.username} just activated SUBS ONLY chat! Loyal supports FTW!`);
        client.say(channel, `/subscribers `);
      }
      if(command === 'subsoff' ||
      command === 'subscribersoff') {
        client.say(channel, `/me Bleep! Bloop! ${tags.username} turned off Subs ONLY chat! Welcome back you filthy followers!`);
        client.say(channel, `/subscribersoff `);
      }
      // Normalizer
      if(command === 'norm' ||
      command === 'normal' ||
      command === 'normalize' ||
      command === 'normalizer') {
        client.say(channel, `/me Bleep! Bloop! ${tags.username} has normalized chat!`);
        client.say(channel, `/emoteonlyoff `);
        client.say(channel, `/followersoff `);
        client.say(channel, `/slowoff `);
        client.say(channel, `/subscribersoff `);
      }
      // uniquechat / uniquechatoff
      // endpoll deletepoll maybe poll? idk how the bot would edit it 

      // Run Ads | TODO Fix Permissions...
      if(command === 'ad' ||
      command === 'ads' ||
      command === 'dab30' ||
      command === 'intermission') {
        client.say(channel, `Bleep! Bloop! Sub to bypass ads! `);
        client.commercial("channel", 30)
        .then((data) => {
        // data returns [channel, seconds]
        }).catch((err) => {
        //
        });
      }
      // Block

    } // MOD | END
    
}); // SCAN MSG | END

// TTV Re-Active
// ==================================
// TO-DO: Add Follower API
// https://api.twitch.tv/kraken/channels/MY_ID/follows?api_version=5&client_id=MY_CLIENT_ID&limit=1
client.on("anongiftpaidupgrade", (channel, username, userstate) => {
    client.whisper(username, `BLEEP! BLOOP! Anon-Sub upgraded!!!`);
});
client.on("ban", (channel, username, reason, userstate) => {
    client.say(channel, `/me BYE FELICIA!!!`);
    client.say(channel, `!kappagen BOP BOP BOP `);
});
client.on("cheer", (channel, userstate, message) => {
    client.say(channel, `/me BLEEP! BLOOP! O'SNAP! Bit hype!!! sarimoBANG`);
    client.say(channel, `!kappagen sarimoHYPE sarimoBITS`);
});
client.on("clearchat", (channel) => {
    client.say(channel, `Chat Rule Reminder`);
    client.say(channel, `/me 1. Do NOT feed the Trolls!`);
    client.say(channel, `/me 2. Do NOT be a Troll!`);
    client.say(channel, `/me 3. Do NOT be another brick in the wall!`);
});
client.on("giftpaidupgrade", (channel, username, sender, userstate) => {
    // Huh? Tier 1 => Tier2
});
client.on("hosting", (channel, target, viewers) => {
    client.say(channel, `/me BLEEP! BLOOP! @Sarimoko is auto-hosting various streamers! For more info: https://cord.sarimoko.com`);
});
client.on("join", (channel, username, self) => {
      console.log('+1 IRC Chatter: ');
});
client.on("part", (channel, username, self) => {
      console.log('-1 IRC Chatter');
    // client.say(channel, `/me -1 Chatter! Where's my bounty hunters?  Essemble the *air-qoutes* search-party *air-qoutes*`);
});
client.on("raided", (channel, username, viewers) => {
    client.say(channel, `/me Welcome raiders!!! We may take your viewership, but we'll never take your FREEDOM!!!`);
    client.say(channel, `!kappagen sarimoRAID sarimoFREEDOM sarimoRAID sarimoFREEDOM sarimoRAID sarimoFREEDOM`);
});
client.on("subgift", (channel, username, streakMonths, recipient, methods, userstate) => {
    let senderCount = ~~userstate["msg-param-sender-count"]; // IDK
    client.say(channel, `/me Thank you for supporting The Sarimoko Show with Gift-Subs!`);
});
client.on("submysterygift", (channel, username, numbOfSubs, methods, userstate) => {
    let senderCount = ~~userstate["msg-param-sender-count"]; // IDK
    client.say(channel, `/me BLEEP! BLOOP! Am I getting hacked? Anon just Gift-Subbed! If I get erased... I love you all!`);
});
client.on("resub", function (channel, username, months, message, userstate, methods) {
    client.say(channel, `/me BLEEP! BLOOP! Legend re-sub! Thanks for your continued support!`);
    client.say(channel, `!kappagen sarimoHYPE sarimoKO`);
});
client.on("subscription", function (channel, username, method, message, userstate) {
    client.say(channel, `/me BLEEP! BLOOP! New subscriber! Spam your new emotes!!! Let's see you're fav!`);
    client.say(channel, `!kappagen sarimoKO sarimoNERD`);
});
client.on("whisper", (from, userstate, message, self) => {
    if (self) return;
    client.say(channel, `/me Bleep! Bloop! Sariboto's Inbox (+1): SEXT Message Recieved!`);
});